dccproc(8)

NAME
dccproc - Distributed Checksum Clearinghouse Procmail Interface

SYNOPSIS
dccproc [-VdAQCHER] [-h homedir] [-m map] [-w whiteclnt] [-T tmpdir] [-a IP-address] [-f env_from] [-t targets] [-x exitcode]
[ -c type, [log-thold,] rej-thold] [ -g [not-] type] [-S header]
[-i infile] [-o outfile] [-l logdir] [-B dnsbl-option] [-L ltype,facility.level]

DESCRIPTION
Dccproc is a low performance DCC client for checking single mail messages for mail filters such as procmail(1)

Dccproc copies a complete SMTP message from standard input or a file to standard output or another file. As it copies the message, it computes the DCC checksums for the message, reports them to a DCC server, and adds a header line to the message. Another program such as procmail(1) can use the added header line to filter mail or the exit dccproc exit status.

Error messages are sent to stderr as well as the system log. Connect stderr and stdout to the same file to see errors in context, but direct stderr to /dev/null to keep DCC error messages out of the mail. The -i option can also be used to separate the error messages.

Dccproc sends reports of checksums related to mail received by DCC clients and queries about the total number of reports of particular checksums. A DCC server receives no mail, address, headers, or other information, but only cryptographically secure checksums of such information. A DCC server cannot determine the text or other information that corresponds to the checksums it receives. It only acts as a clearinghouse of counts of checksums computed by clients.

The checksums of private mail, the internal mail,and other mail that is known to not be unsolicited bulk can be listed in a whitelist specified with

When sendmail(8) is used, dccm(8) is a better DCC interface. Dccifd(8) is more efficient than dccproc because it is a daemon, but that has costs in complexity. See dccsight(8) for a way to use previously computed checksums.

  OPTIONS
The following options are available:

-V  displays the program's version.

-d  enables debugging output from the DCC client software. Additional -d options increase the number of messages. One causes error messages to be sent to STDERR as well as the system log.

-A  adds to existing X-DCC headers (if any) of the brand of the current server instead of replacing existing headers.

-Q  only queries the DCC server about the checksums of messages instead of reporting and then querying. This is useful when dccproc is used to filter mail that has already been reported to a DCC server by another DCC client such as dccm(8). No single mail message should be reported to a DCC server more than once per recipient.

    It is better to use MXDCC lines in the -w whiteclnt file for your MX mail servers that use DCC than -Q

-C  outputs only the X-DCC header and the checksums for the message.

-H  outputs only the X-DCC header.

-E  adds lines to the start of the log file turned on with -l and -c describing what might have been the envelope of the message. The information for the inferred envelope comes from arguments including -a and headers in the message when -R is used. No lines are generated for which no information is available, such as the envelope recipient.

-R  says the first Received lines have the standard "helo (name [address])..." format and the address is that of the SMTP client that would otherwise be provided with -a. The -a option should be used if the local SMTP server adds a Received line with some other format or does not add a Received line. Received headers specifying IP addresses marked MX or MXDCC in the -w whiteclnt file are skipped.

-h homedir
    overrides the default DCC home directory, /usr/local/dcc.

-m map
    specifies a name or path of the memory mapped parameter file instead of the default map in the DCC home directory. It should be created with the new map operation of the cdcc(8) command.

-w whiteclnt
    specifies an optional file containing SMTP client IP addresses and SMTP headers of mail that do not need X-DCC headers and whose checksums should not be reported to the DCC server. It can also contain checksums of spam. If the pathname is not absolute, it is relative to the DCC home directory. Thus, individual users with private whitelists usually specify them with absolute paths. Common whitelists shared by users must be in the DCC home directory or one of its subdirectories and owned by the set-UID user of dccproc. It is useful to include a common or system-wide whitelist in private lists.

    Because the contents of the whiteclnt file are used frequently, a companion file is automatically created and maintained. It has the same pathname but with an added suffix of .dccw. It contains a memory mapped hash table of the main file.

    Option lines can be used to modify many aspects of dccproc filtering, as described in the main dcc(8) man page. For example, an option spam-trap-accept line turns off DCC filtering and reports the message as spam.

-T tmpdir
    changes the default directory for temporary files from the system default. The system default is often /tmp.

-a IP-address
    specifies the IP address (not the host name) of the immediately previous SMTP client. It is often not available. -a 0.0.0.0 is ignored. -a. The -a option should be used instead of -R if the local SMTP server adds a Received line with some other format or does not add a Received line.

-f env_from
    specifies the RFC 821 envelope "Mail From" value with which the message arrived. It is often not available. If -f is not present, the contents of the first Return-Path: or UNIX style From_ header is used. The env_from string is often but need not be bracketed with "<>".

-t targets
    specifies the number of addressees of the message if other than 1. The string many instead of a number asserts that there were too many addressees and that the message is unsolicited bulk email.

-x exitcode
    specifies the code or status with which dccproc exits if the -c thresholds are reached or the -w whiteclnt file blacklists the message.

    The default value is EX_NOUSER. EX_NOUSER is 67 on many systems. Use 0 to always exit successfully.

-c  type, [log-thold,] rej-thold sets logging and "spam" thresholds for checksum type. The checksum types are IP, env_From, From, Message-ID, substitute, Received, Body, Fuz1, Fuz2, rep-total, and rep. The first six, IP through substitute, have no effect except when a local DCC server configured with -K is used. The substitute thresholds apply to the first substitute heading encountered in the mail message. The string ALL sets thresholds for all types, but is unlikely to be useful except for setting logging thresholds. The string CMN specifies the commonly used checksums Body, Fuz1, and Fuz2. Rej-thold and log-thold must be numbers, the string NEVER, or the string MANY indicating millions of targets. Counts from the DCC server as large as the threshold for any single type are taken as sufficient evidence that the message should be logged or rejected.

    Log-thold is the threshold at which messages are logged. It can be handy to log messages at a lower threshold to find solicited bulk mail sources such as mailing lists. If no logging threshold is set, only rejected mail and messages with complicated combinations of white and blacklisting are logged. Messages that reach at least one of their rejection thresholds are logged regardless of logging thresholds.

    Rej-thold is the threshold at which messages are considered "bulk," and so should be rejected or discarded if not whitelisted.

    DCC Reputation thresholds in the commercial version of DCC are controlled by thresholds on checksum types rep and rep-total. The DCC Reputations of IP addresses that the DCC database says have sent more than rep-total,log-thold are computed and messages from those addresses are logged. Messages from IP addresses with DCC Reputations of at least the rep,rej-thold rejection threshold can be rejected. The DCC Reputation of an IP address is the percentage of its messages known to have been sent to at least 10 recipients. The defaults are equivalent to rep,never and rep-total,never,20.

    Bulk DCC Reputations do not reject mail unless enabled by an option DCC-rep-on line in a whiteclnt file.

    The checksums of locally whitelisted messages are not checked with the DCC server and so only the number of targets of the current copy of a whitelisted message are compared against the thresholds.

    The default is ALL,NEVER, so that nothing is discarded, rejected, or logged. A common choice is CMN,25,50 to reject or discard mail with common bodies except as overridden by the whitelist of the DCC server, the sendmail ${dcc_isspam} and ${dcc_notspam} macros, and -g, and -w.

-g  [not-] type indicates that whitelisted, OK or OK2, counts from the DCC server for a type of checksum are to be believed. They should be ignored if prefixed with not-. Type is one of the same set of strings as for -c. Only IP, env_From, and From are likely choices. By default all three are honored, and hence the need for not-.

-S hdr
    adds to the list of substitute or locally chosen headers that are checked with the -w whiteclnt file and sent to the DCC server. The checksum of the last header of type hdr found in the message is checked. As many as 6 different substitute headers can be specified, but only the checksum of the first of the 6 will be sent to the DCC server.

-i infile
    specifies an input file for the entire message instead of standard input. If not absolute, the pathname is interpreted relative to the directory in which dccproc was started.

-o outfile
    specifies an output file for the entire message including headers instead of standard output. If not absolute, the pathname is interpreted relative to the directory in which dccproc was started.

-l logdir
    specifies a directory for copies of messages whose checksum target counts exceed -c thresholds. The format of each file is affected by -E.

    See the FILES section below concerning the contents of the files. See also the option log-subdirectory-{day,hour,minute} lines in whiteclnt files described in dcc(8).

    The directory is relative to the DCC home directory if it is not absolute

-B dnsbl-option
    enables DNS blacklist checks of the SMTP client IP address, SMTP envelope Mail_From sender domain name, and of host names in URLs in the message body. Body URL blacklisting has too many false positives to use on abuse mailboxes. It is less effective than greylisting with dccm(8) or dccifd(8) but can be useful in situations where greylisting cannot be used.

    Dnsbl-option is either one of the -B set:option forms or
        -B
        domain[any[,bltype]]

        -B
        domain[,IPaddr
        [/xx[,bltype]]]

        -B
        domain[,IPaddr
        [-IPaddrHI[,bltype]]]

    Domain is a DNS blacklist domain such as example.com that will be searched. The string any, IPaddr, IPaddr/xxx, or IPaddrLO-IPaddrHI, specifies which IP addresses found in the DNS blacklist say that mail messages should be rejected "127.0.0.2" is assumed if no address(es) are specified. IPv6 addresses can be specified with the usual colon (:) notation. Host names can be used instead of numeric addresses. The type of DNS blacklist is specified by bltype as name, all-names, IPv4, or IPv6. Given an envelope sender domain name or a domain name in a URL of spam.domain.org and a blacklist of type name, spam.domain.org.example.com will be looked up. The names spam.domain.org.example.com, domain.org.example.com, and org.example.com will be looked up in blacklists of type all-names. Use names with DNS blacklists that use wild cards for speed but all-names for other DNS name blacklists. Blacklist types of IPv4 and IPv6 require that the domain name in a URL sender address be resolved into an IPv4 or IPv6 address. The resolved address from the mail message is then written as a reversed string of decimal octets to check the DNS blacklist, as in 2.0.0.127.example.com.

    More than one blacklist can be specified and blacklists can be grouped with -B set:group=X. All searching within a group of blacklists is stopped at the first positive result.

    Unlike dccm(8) and dccifd(8), no option DNSBL-on line is required in the whiteclnt file. A -B argument is sufficient to show that DNSBL filtering is wanted by the dccproc user.

    -B set:no-client
        implies that SMTP client IP addresses and reverse DNS domain names should not be checked in the following blacklists.
        -B set:client restores the default for the following blacklists.

    -B set:no-mail_host
        implies that SMTP envelope Mail_From sender domain names should not be checked in the following blacklists. -B set:mail_host restores the default.

    -B set:no-URL
        says that URLs in the message body should not be checked in the in the following blacklists. -B set:URL restores the default.

    -B set:no-MX
        says MX servers of sender Mail_From domain names and host names in URLs should not be checked in the following blacklists.
        -B set:MX restores the default.

    -B set:no-NS
        says DNS servers of sender Mail_From domain names and host names in URLs should not be checked in the following blacklists. -B set:NS restores the default.

    -B set:defaults
        is equivalent to all of -B set:client
        -B set:mail_host -B set:URL -B set:MX and -B set:NS

    -B set:group=X
        adds following DNS blacklists specified with
            -B
            domain[,IPaddr
            [/xx[,bltype]]]

        to group 1, 2, or 3.

    -B set:debug=X
        sets the DNS blacklist logging level

    -B set:msg-secs=S
        limits dccproc to S seconds total for checking all DNS blacklists. The default is 25.

    -B set:URL-secs=S
        limits dccproc to at most S seconds resolving and checking any single URL. The default is 11. Some spam contains dozens of URLs and some "spamvertised" URLs contain host names that need minutes to resolve. Busy mail systems cannot afford to spend minutes checking each incoming mail message.

-L ltype,facility.level
    specifies how messages should be logged. Ltype must be error, info, or off to indicate which of the two types of messages are being controlled or to turn off all syslog(3) messages from dccproc. Level must be a syslog(3) level among EMERG, ALERT, CRIT, ERR, WARNING, NOTICE, INFO, and DEBUG. Facility must be among AUTH, AUTHPRIV, CRON, DAEMON, FTP, KERN, LPR, MAIL, NEWS, USER, UUCP, and LOCAL0 through LOCAL7. The default is equivalent to
        -L info,MAIL.NOTICE -L error,MAIL.ERR

dccproc exits with 0 on success and with the -x value if the -c thresholds are reached or the -w whiteclnt file blacklists the message. If at all possible, the input mail message is output to standard output or the -o outfile despite errors. If possible, error messages are put into the system log instead of being mixed with the output mail message. The exit status is zero for errors so that the mail message will not be rejected.

If dccproc is run more than 500 times in fewer than 5000 seconds, dccproc tries to start Dccifd(8). The attempt is made at most once per hour. Dccifd is significantly more efficient than dccproc. With luck, mechanisms such as SpamAssassin will notice when dccifd is running and switch to dccifd.

FILES
/usr/local/dcc
    DCC home directory in which other files are found.
map memory mapped file in the DCC home directory of information concerning DCC servers.
whiteclnt
    contains the client whitelist in the format described in dcc(8).
whiteclnt.dccw
    is a memory mapped hash table corresponding to the whiteclnt file.
tmpdir
    contains temporary files created and deleted as dccproc processes the message.
logdir
    is an optional directory specified with -l and containing marked mail. Each file in the directory contains one message, at least one of whose checksums reached one of its -c thresholds. The entire body of the SMTP message including its header is followed by the checksums for the message.

EXAMPLES
The following procmailrc(5) rule adds an X-DCC header to passing mail

    :0 f
    | /usr/local/bin/dccproc -ERw whiteclnt

This procmailrc(5) recipe rejects mail with total counts of 10 or larger for the commonly used checksums:

    :0 fW
    | /usr/local/bin/dccproc -ERw whiteclnt -ccmn,10
    :0 e
    {
        EXITCODE=67
        :0
        /dev/null
    }

SEE ALSO
cdcc(8), dcc(8), dbclean(8), dccd(8), dblist(8), dccifd(8), dccm(8), dccsight(8), mail(1), procmail(1).

HISTORY
Distributed Checksum Clearinghouses are based on an idea of Paul Vixie. Implementation of dccproc was started at Rhyolite Software in 2000. This document describes version 1.3.115.

BUGS
dccproc uses -c where dccm(8) uses -t.